(*******************************************************)
(** INFORMATIKFORUM e.V. Simmerath                    **)
(** PASCAL Feldversuch                                **)
(** Alle Rechte vorbehalten                           **)
(*******************************************************)
(******************************************)
      program buecher ( titeldatei,output);
(*========DEKLARATIONEN====================================*)
(*________TYPE-Deklaration_________________________________*)
      type    zeiger    =     ^buch ;
              merkmal   =     ( autor , titel , signatur );
              zeigerfeld=     array(.merkmal.) of zeiger;
              string_20 =     array(.1..20.) of char;
              buch      =     record
                              text:array(.merkmal.) of
                                   string_20;
                              naechster:zeigerfeld
                              end;
              dateibuch =     record
                              text:array(.merkmal.) of
                                   string_20;
                              end;
(*________VAR-Deklaration_________________________________*)
      var
          wurzel          : zeigerfeld;
          neubuch ,
          aktuell         : zeiger;
          titeldatei      : file of dateibuch;
          werk            : dateibuch;
          art ,
          zaehler            : merkmal;
(*=====PROZEDUR===========================================*)



      Procedure einordnen ( art         : merkmal    ;
                            var wurzel  : zeigerfeld ;
                            var neubuch : zeiger       ) ;
           var
              vorgaenger,
              nachfolger  : zeiger;
              (*____lokale___Funktion_____________________*)
              function weiter ( var neu ,
                                nach : zeiger ) : boolean ;
              begin
                    if nach = nil
                     then
                      weiter  := false
                    else
                     begin
                      if nach^.text(.art.) <
                         neu^.text(.art.)
                         then
                          weiter := true
                         else
                          weiter := false
                     end
              end;
              (*________________Ende_lok_Funktion_*)
           begin
            if wurzel(.art.) = nil
             then
              begin
               wurzel(.art.)             := neubuch;
               neubuch^.naechster(.art.) := nil
              end
             else
              begin
               vorgaenger := wurzel(.art.);
               nachfolger := wurzel(.art.);
               while weiter ( neubuch , nachfolger )
                do
                 begin
                  vorgaenger := nachfolger;
                  nachfolger := nachfolger^.naechster(.art.);
                 end;
               if nachfolger = nil
                then
                 begin
                  vorgaenger^.naechster(.art.) := neubuch;
                  neubuch^.naechster(.art.)    := nil
                 end
                else
                 begin
                  if vorgaenger = nachfolger
                   then
                    begin
                     wurzel(.art.) := neubuch;
                     neubuch^.naechster(.art.) := nachfolger
                    end
                   else
                    begin
                     vorgaenger^.naechster(.art.) := neubuch;
                     neubuch^.naechster(.art.)    := nachfolger
                    end
                   end
                  end
           end;
(*-------------------Hauptprogram------------------------------*)
           begin

           (*-------------------------------------*)
           (* der folgende befehl ist compiler-   *)
           (* abhaengig Er verbindet die          *)
           (* Dateivariable mit der Datei         *)

            assign(titeldatei,'buch.dat');

           (*-------------------------------------*)

            reset(titeldatei);
            for art := autor to signatur
             do
              wurzel(.art.) := nil;
            while not eof(titeldatei)
             do
              begin
               read(titeldatei,werk);
               new(neubuch);
               for art := autor to signatur
                do
                 begin
                  writeln(werk.text(.art.));
                  neubuch^.text(.art.) := werk.text(.art.);
                 end;
               for art := autor to signatur
                do
                einordnen ( art ,
                                       wurzel ,
                                       neubuch          );
              end;
                for art := autor to signatur
                 do
                 begin
                  case art of
                   autor    : write('----autoren---');
                   titel    : write('----titel-----');
                   signatur : write('----signatur--')
                  end;
                  writeln;
                  aktuell := wurzel(.art.);
                  while aktuell <> nil
                   do
                    begin
                     writeln(aktuell^.text(.art.));
                     for zaehler := autor to signatur
                      do
                       if zaehler <> art then
                        write(aktuell^.text(.zaehler.),' ');
                     writeln;
                     write('==============================');
                     writeln;
                     aktuell := aktuell^.naechster(.art.)
                    end
                end;
(***********************************************************)
(*         ENDE                                            *)
(***********************************************************)
           (*-----------------------------------*)
           (* der folgende Befehl ist compiler- *)
           (* abhaengig                         *)

           close(titeldatei)

           (*-----------------------------------*)
           end.

(*******************************************************)
(** INFORMATIKFORUM e.V. Simmerath                    **)
(** PASCAL Feldversuch                ENDE            **)
(** Alle Rechte vorbehalten                           **)
(*******************************************************)